// Bacasable9Stereo.pde
// Gerard Paresys Guykayser
// 31 10 2015
//
// OK Processing 2.0.3 MacOSX.6
// OK Processing 2.2.1 MacOSX.10
// NON Processing 3
// OK Kinect 1414 (original kinect)
//
// Utilise la "contributed library" SimpleOpenNI Version 1.96 by Max Rheiner
// "Processing Wrapper for the OpenNI/Kinect library"
// http://code.google.com/p/simple-openni
// http://iad.zhdk.ch/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// cf Processing/libraries/SimpleOpenNI/examples/OpenNI/DepthImage/DepthImage.pde
//
// Touche Clavier:
//   D Image Depth  Palette 256 brightness
//   1 Palette 256  Noir -> Rouge
//   3 Palette 256  Noir -> Bleu -> Blanc -> Jaune -> Orange
//   5 Palette 256  Noir -> Blanc
//   7 Palette 256 Rouge -> Blanc (Palette "Labomedia" claire)
//   9 Palette 256  Noir -> Rose  (Palette "Labomedia" sombre)
//   0 Palette 256 Rouge -> Rose  (Palette "Labomedia" ...)
//   G Inversion des palettes 256
//   E Image Depth  Palette en mm
//   C Couleur pour Palette mm
//   I Image InfraRed
//   H Image HeightMap
//   V Visu Mesures et 12 zones
//   T Fragment: Transcription 1
//   M Fragment: Mot           2
//   Y Fragment: Syllabe       3
//   P Fragment: Phoneme       4
//   N Miroir IR
//   Z Zoom
//   B Blur
//   6 Blur +
//   4 Blur -
//   8 Lumiere +
//   2 Lumiere -
//   Fleche Up    + 1 pixel dY
//   Fleche Down  - 1 pixel dY
//   Fleche Left  - 1 pixel dX
//   Fleche Right + 1 pixel dX
//   S Sauve l'ecran (format png) dans le dossier du sketch (nombre = Numero frame)
//
// Voir APC19 pour plusieurs lecteurs Audio simultanes
//
import SimpleOpenNI.*;
import peasy.*;
import ddf.minim.*;         // pour AudioPlayer

boolean FlagKinect = true;
boolean PleinEcran = true;
boolean FlagPeasyCam = false;
boolean Miroir = false; 
String Image = "D";
Boolean Zoom = false;
Boolean Couleur = true;
Boolean Blur = true;
int QBlur = 20;
Boolean Visu = true;
boolean Verbose = false;
int Fragment = 2; // 1:Transcription 2:Mot 3:Syllabe 4:Phoneme 
int Seuil = 100; // 279
Boolean Sauve = false;
int Palette = 1;

int TailleCarre640 = 145; // = 232 * 640 / 1024;
int TailleCarre; 

int x1 = 0, y1 = 0, x2 = 640, y2 = 480; 
float b;

SimpleOpenNI  Kinect;

PImage Image1;
PImage Pseudo;

int TailleX = 320, TailleY = 240, TailleXdemi = 160, TailleYdemi = 120;
float[][] hm  = new float[TailleX][TailleY]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[TailleX][TailleY];

PeasyCam pcam;
CameraState  pcamstate;

int[] depthMap;
int index;
float Facteur = 10;
float Delta = 0;

int[] Palette256; 
int[] Palettemm; 

int NVoix = 12, Voix = 0;
int[] Acc = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

String ExtensionFichierAudio = ".wav"; // ".wav" ".mp3"
String Content1 = "", Content2 = "", Content = "";
String[] TableNomFichier = {
  "ESLO1_ENT_010.xml", 
  "ESLO1_ENT_110.xml", 
  "ESLO1_INTPERS_423.xml", 
  "ESLO1_INTPERS_439.xml", 
  "ESLO2_CONF_1243.xml", 
  "ESLO2_DIA_1227.xml", 
  "ESLO2_ENT_1012.xml", 
  "ESLO2_ENT_1027.xml", 
  "ESLO2_ENT_1028.xml", 
  "ESLO2_ENT_1049.xml", 
  "ESLO2_ENT_1076.xml", 
  "ESLO2_REPAS_1270.xml"
}; 
String NomFichierXML = TableNomFichier[0]; //

XML[][] XMLTranscription = new XML[NVoix][200];
XML[][] XMLPhoneme       = new XML[NVoix][200];
XML[][] XMLMot           = new XML[NVoix][200];
XML[][] XMLSyllabe       = new XML[NVoix][200];

int[] NbrTranscription = new int[NVoix];
int[] NbrPhoneme       = new int[NVoix];
int[] NbrMot           = new int[NVoix];
int[] NbrSyllabe       = new int[NVoix];


Minim minim;
// AudioPlayer player;
AudioPlayer[] LecteurAudio = new AudioPlayer[NVoix];
float xmin, xmax;  // Temps en seconde
int TempsVoix[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
}; //ms

boolean[] FichierOuvert = {
  false, false, false, false, false, false, false, false, false, false, false, false, false
};
int IndexXML = 0;
float Temps, TempsPause = 0, TempsDebutPause = 0;
int ZoneMaxAvant = 0, ZoneMax = 0, Max = 0;
String S = "";
int i = 0;

int Dx1 = 0, Dy1 = 0;

PFont maFonte;

void setup() {
  // size(640, 480, P3D);
  // size(1280, 960, P3D);
  if (PleinEcran) size(displayWidth, displayHeight, P3D);
  else size(640, 480, P3D);
  x2 = width;
  y2 = height;
  TailleCarre = TailleCarre640 * width / 640;

  frameRate(20);


  Pseudo = loadImage("PseudoImage.png"); // Image 640 x 480 en l'absence de Kinect

  if (FlagKinect) {
    Kinect = new SimpleOpenNI(this);
    if (Kinect.isInit() == false) {
      println("Can't init SimpleOpenNI, maybe the Kinect is not connected!"); 
      exit();
      return;
    }
    Kinect.setMirror(Miroir);
    Kinect.enableDepth();
    // Kinect.enableRGB();
    Kinect.enableIR(); // IR is only available if there is no RGBImage activated at the same time
    Kinect.enableUser();
    // Kinect.alternativeViewPointDepthToImage();
    // Kinect.setDepthColorSyncEnabled(true);
    println("Kinect.depthWidth() = " + Kinect.depthWidth() + "    Kinect.depthHeight() = " + Kinect.depthHeight());
  } 
  else println("setup FlagKinect = " + FlagKinect);

  if (FlagPeasyCam) {
    // pcam = new PeasyCam(this, width/2, height/2, 0, 600); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
    pcam = new PeasyCam(this, width/2, height/2, 0, 300); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
    pcam.setMinimumDistance(50);
    pcam.setMaximumDistance(1000);
    // pcam.rotateX(-PI/4);
    pcam.rotateX(-PI/8);
    pcamstate = pcam.getState();
  }

  Palette256 = new int[256];
  CalculPalette256(Palette);

  Palettemm = new int[1070];
  for (int i=0; i<1070; i++) {
    if (i > 1060)      Palettemm[i] = color(0, 0, 80);  
    else if (i > 1040) Palettemm[i] = color(0, 50, 102);  
    else if (i > 1020) Palettemm[i] = color(0, 97, 71);// color(150, 150, 0);  
    else if (i > 1000)  Palettemm[i] = color(0, 200, 0); // color(200, 200, 0);  
    // else if (i > 980)  Palettemm[i] = color(176, 226, 255);  
    else if (i > 980)  Palettemm[i] = color(150, 150, 0); //color(0, 97, 71); // color(16, 122, 47);  
    else if (i > 960)  Palettemm[i] = color(200, 200, 0); // color(0, 255, 0); // color(16, 122, 47);  
    else if (i > 940)  Palettemm[i] = color(161, 67, 0);  
    else if (i > 920)  Palettemm[i] = color(130, 30, 30);  
    else if (i > 900)  Palettemm[i] = color(255, 20, 0);
  }

  //  File Fichier = new File(dataPath(NomFichierXML));
  //  if (Fichier.exists()) {
  //    Ouverture(NomFichierXML);
  //    // Nom = split(Fichier.getName(), '.')[0];
  //  } else selectInput("select the XML File (format Praat textGrid):", "SelectionFichier");

  minim = new Minim(this);
  for (Voix = 0; Voix < NVoix; Voix++) Ouverture(TableNomFichier[Voix], Voix);

  maFonte = loadFont("Verdana-48.vlw");    // Au choix
  textFont(maFonte);
}

void draw() {
  // background(0);  // 

  //  if (Blur) {
  //    noStroke();
  //    fill(0, QBlur); // semi-transparent black
  //    rect(0, 0, width, height);
  //  } 
  //  else background(0);

  if (FlagKinect) {
    Kinect.update();
    if (Image.equals("H")) {
      depthMap = Kinect.depthMap();
      Calculhm();
      pushMatrix();
      translate(width/2, height/2);
      paintLandscape();
      popMatrix();
    } 
    else {
      if (Image.equals("D")) {
        Image1 = Kinect.depthImage();
        for (int i = 0; i < (Image1.width * Image1.height); i++) {
          b = brightness(Image1.pixels[i]) * Facteur / 10;
          b = max(min(b, 255), 0);
          Image1.pixels[i] = Palette256[int(b)];
        }
      }
      if (Image.equals("E")) {
        Image1 = Kinect.depthImage();
        depthMap = Kinect.depthMap(); // depthMap en mm
        if (Couleur) {
          for (int i = 0; i < (Image1.width * Image1.height); i++) {
            b = depthMap[i] + Delta;
            b = max(min(b, 1069), 0);
            Image1.pixels[i] = Palettemm[int(b)];
          }
        }
        else {
          for (int i = 0; i < (Image1.width * Image1.height); i++) {
            b = depthMap[i]  + Delta;
            b = (b - 870) / 200 * 256;
            b = max(min(b, 255), 0);
            Image1.pixels[i] = color(b);
          }
        }
      }
      // if (Image.equals("R")) image(Kinect.rgbImage(), x1, y1, x2, y2);
      if (Image.equals("I")) Image1 = Kinect.irImage();
      Image1.updatePixels();
    }
  } 
  else Image1 = Pseudo;

  if (Blur) tint(255, QBlur); // Apply transparency without changing color
  else noTint(); 
  // image(Image1, x1, y1, x2, y2);
  image(Image1, x1 + Dx1, y1 + Dy1, x2, y2);

  // Mesure 4 x 3 carres TailleCarre x TailleCarre = 145 x 145
  if (FlagKinect) Image1 = Kinect.depthImage();
  Image1.loadPixels();
  fill(255, 0, 0);            // Rouge
  // textAlign(CENTER, CENTER);       //RIGHT LEFT BOTTOM BASELINE TOP
  textAlign(CENTER);       //RIGHT LEFT BOTTOM BASELINE TOP
  textSize(32);
  for (int z = 0; z < 12; z++) {
    Acc[z] = 0;
    int Decalage = (320 - 2 * TailleCarre640) + ((z % 4) * TailleCarre640) + ((480 - (3 * TailleCarre640) + ((z / 4) * TailleCarre640)) * 640);
    for (int u = 0; u < TailleCarre640; u++) {
      for (int v = 0; v < TailleCarre640; v++) {
        Acc[z] = Acc[z] + int(brightness(Image1.pixels[u + (v * 640) + Decalage]));
      }
    }
    Acc[z] = Acc[z] / 10000;
    if (Visu) text(Acc[z], TextX(z % 4), TextY(z / 4));
  }
  ZoneMax = 0;
  Max = 0;
  for (int z = 0; z < Acc.length; z++) {
    if (Acc[z] > Max) {
      Max = Acc[z];
      ZoneMax = z;
    }
  }
  // println("ZoneMax = " + ZoneMax);
  if (Visu) text("ZoneMax = " + ZoneMax, width / 2, height - 20);
  if (ZoneMaxAvant != ZoneMax) {
    ZoneMaxAvant = ZoneMax;
    // Ouverture(TableNomFichier[ZoneMax]);
    // Ouverture1Fois(ZoneMax);
  }  

  for (Voix = 0; Voix < NVoix; Voix++) {
    if (millis() > TempsVoix[Voix]) LecteurAudio[Voix].pause(); //
  }

  Voix = int(random(NVoix));
  // Voix = 6;

  if (Fragment == 1) { // Transcription
    i = int(random(NbrTranscription[Voix]));
    S = XMLTranscription[Voix][i].getContent();
    xmin = XMLTranscription[Voix][i].getFloat("xmin");// Temps en seconde
    xmax = XMLTranscription[Voix][i].getFloat("xmax");// Temps en seconde
  }
  else if (Fragment == 2) { // Mot
    i = int(random(NbrMot[Voix]));
    S = XMLMot[Voix][i].getContent();
    xmin = XMLMot[Voix][i].getFloat("xmin");// Temps en seconde
    xmax = XMLMot[Voix][i].getFloat("xmax");// Temps en seconde
  }
  else if (Fragment == 3) { // Syllabe
    i = int(random(NbrSyllabe[Voix]));
    S = XMLSyllabe[Voix][i].getContent();
    xmin = XMLSyllabe[Voix][i].getFloat("xmin");// Temps en seconde
    xmax = XMLSyllabe[Voix][i].getFloat("xmax");// Temps en seconde
  }
  else if (Fragment == 4) { // Phoneme
    i = int(random(NbrPhoneme[Voix]));
    S = XMLPhoneme[Voix][i].getContent();
    xmin = XMLPhoneme[Voix][i].getFloat("xmin");// Temps en seconde
    xmax = XMLPhoneme[Voix][i].getFloat("xmax");// Temps en seconde
  }
  textSize(32);
  if (Acc[Voix] > Seuil) { // 279
    // LecteurFragmentAudio(Voix, int(xmin * 1000), int(xmax * 1000));
    if (millis() > TempsVoix[Voix]) {
      LecteurAudio[Voix].play(int(xmin * 1000));
      // println("Frame = " + frameCount + "  millis = " + millis() + "  TempsVoix[Voix] = " + TempsVoix[Voix] + "  Voix = " + Voix + "   i = " + i + "   S = " + S +"  min = " + int(xmin * 1000) +"  max = " + int(xmax * 1000));
      TempsVoix[Voix] = millis() + int((xmax-xmin) * 1000);
      fill(255, 255, 255); 
      text(S, TextX(Voix % 4), TextY(Voix / 4) + 30);
    }
  }

  if (Visu) { // 4 x 3 = 12 carres rouges
    stroke(255, 0, 0); // Rouge
    strokeWeight(1);
    noFill();
    // for (int x = 0; x < 5; x++) line(x * width / 4, 0, x * width / 4, height);
    for (int x = -2; x < 3; x++) {
      int X = width / 2 + x * TailleCarre;
      line(X, height - 3 * TailleCarre, X, height);
    }
    // for (int y = 0; y < 4; y++) line(0, y * height / 3, width, y * height / 3);
    for (int y = -3; y < 1; y++) {
      int Y = height + y * TailleCarre;
      // line(0, Y, width, Y);
      line(width / 2 - 2  * TailleCarre, Y, width / 2 + 2  * TailleCarre, Y);
    }

    textSize(16);
    fill(255, 0, 0); 
    for (Voix = 0; Voix < NVoix; Voix++) {
      // text(TableNomFichier[Voix], TextX(Voix % 4), TextY(Voix / 4) - 30);
      String[] list = split(TableNomFichier[Voix], '.');
      text(list[0], TextX(Voix % 4), TextY(Voix / 4) - 30);
    }
  }
  frame.setTitle( "Kinect     " + int(10 * frameRate) / 10.0 + " fps");
  if (Sauve) {
    Sauve = false;
    saveFrame("Display-" + frameCount + ".png"); // S Sauve l'ecran
  }
}

void Calculhm1() {
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(brightness(Image1.pixels[(x * 2) + (y * 4 * TailleX)]) / 8.f, 100), 0);
  }
}

void Calculhm2() {
  // Voir: SimpleOpenNI/examples/OpenNI/AlternativeViewpoint3d/AlternativeViewpoint3d.pde
  //   et: SimpleOpenNI/examples/Extensions/IntersectionTest/IntersectionTest.pde
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) { 
      index = (x * 2) + (y * 2 * Kinect.depthWidth());
      // hm[x][y] = depthMap[index];
      // hm[x][y] = max(min(depthMap[index]/ 40.f, 100), 0);
      hm[x][y] = max(min(depthMap[index]/ Facteur, 100), 0);
    }
  }
}

void Calculhm3() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = max(min(
      ( brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]) 
        + brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)])
        + brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])
        + brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  32.0, 100.0), -3.0);
  }
}

void Calculhm() {
  // Supprimer Brightness car image en gris
  Image1 = Kinect.depthImage();
  // Image1.resize(TailleX, TailleY);
  Image1.loadPixels();
  for (int x = 0; x < TailleX; x++) {
    // for (int y = 0; y < TailleY; y++) hm[x][y] = max(min(brightness(Image1.pixels[(x*2) + ((y*2) * TailleX)])/ 8.f, 100), 0);
    for (int y = 0; y < TailleY; y++) 
      hm[x][y] = min(max(max(
      brightness(Image1.pixels[(x * 2) +     (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2) + 1 + (y * 4 * TailleX)]), 
      brightness(Image1.pixels[(x * 2)     + (((y * 4) + 2 ) * TailleX)])), 
      brightness(Image1.pixels[(x * 2) + 1 + (((y * 4) + 2 ) * TailleX)]))
        /  10.0, 100.0);
  }
}

void paintLandscape() {
  noStroke();
  scale(1.8);
  if (Blur) tint(255, 20); // Apply transparency without changing color
  else noTint(); 

  for ( int x = 3; x < TailleX-5; x++) {
    beginShape(QUADS);
    for ( int y = 3; y < TailleY-5; y++) {
      if (Couleur) {
        // b = hm[x][y] * 8;
        b = hm[x][y] * Facteur;
        // if ((b >= 0) & (b < 256)) fill(Palette256[int(b)]);
        b = max(min(b, 255), 0);
        fill(Palette256[int(b)]);
      }
      // else fill((hm[x][y] *12), (hm[x][y] * 12), (hm[x][y] * 12));
      // else fill((hm[x][y] *8), (hm[x][y] * 8), (hm[x][y] * 8));
      else fill((hm[x][y] * Facteur));
      vertex(x     - TailleXdemi, y     - TailleYdemi, hm[x]  [y]);
      vertex(x + 1 - TailleXdemi, y     - TailleYdemi, hm[x+1][y]);
      vertex(x + 1 - TailleXdemi, y + 1 - TailleYdemi, hm[x+1][y+1]);
      vertex(x     - TailleXdemi, y + 1 - TailleYdemi, hm[x]  [y+1]);
    }
    endShape();
  }
}


void keyPressed() {
  if ( key == 'd' || key == 'D' ) Image = "D";
  else if ( key == 'e' || key == 'E' ) Image = "E";
  // else if ( key == 'r' || key == 'R' ) Image = "R";
  else if ( key == 'b' || key == 'B' ) Blur = !Blur;
  else if ( key == 't' || key == 'T' ) Fragment = 1;
  else if ( key == 'm' || key == 'M' ) Fragment = 2;
  else if ( key == 'y' || key == 'Y' ) Fragment = 3;
  else if ( key == 'p' || key == 'P' ) Fragment = 4;
  else if ( key == 'i' || key == 'I' ) Image = "I";
  else if ( key == 'h' || key == 'H' ) Image = "H";
  else if ( key == 'v' || key == 'V' ) Visu = !Visu;
  else if ( key == 'z' || key == 'Z' ) {
    Zoom      = !Zoom;
    if (Zoom) {
      x1 = -320;
      y1 = -240;
      x2 = 1280;
      y2 = 960;
    } 
    else {
      x1 = 0;
      y1 = 0;
      x2 = width;   //      x2 = 640;
      y2 = height;  //      y2 = 480;
    }
  } 
  else if ( key == 'c' || key == 'C' ) Couleur      = !Couleur;
  else if ( key == 's' || key == 'S' ) Sauve = true;
  else if ( key == 'n' || key == 'N' ) {
    Miroir = !Miroir; 
    Kinect.setMirror(Miroir);
    // Kinect.enableDepth();
  } 
  else if ( key == '4' ) {
    QBlur = QBlur - 5;
    QBlur = max (QBlur, 0);
    println("QBlur = " + QBlur);
  } 
  else if ( key == '6' ) {
    QBlur = QBlur + 5;
    QBlur = min (QBlur, 100);
    println("QBlur = " + QBlur);
  } 
  else if ( key == '2' ) {
    Facteur = Facteur / 1.2;
    Delta = Delta + 1;
    println("Facteur = " + Facteur);
  } 
  else if ( key == '8' ) {
    Facteur = Facteur * 1.2;
    Delta = Delta - 1;
    println("Facteur = " + Facteur);
  } 
  else if ( key == '1' ) CalculPalette256(1); 
  else if ( key == '3' ) CalculPalette256(3); 
  else if ( key == '5' ) CalculPalette256(5); 
  else if ( key == '7' ) CalculPalette256(7); 
  else if ( key == '9' ) CalculPalette256(9); 
  else if ( key == '0' ) CalculPalette256(0); 
  else if ( key == 'g' || key == 'G' ) CalculInversePalette256();
  if (key == CODED) {
    if (keyCode == UP) {
      Dy1 = Dy1 + 10;
      println("Dy1 = " + Dy1);
    } 
    else if (keyCode == DOWN) {
      Dy1 = Dy1 - 10;
      println("Dy1 = " + Dy1);
    } 
    else if (keyCode == LEFT) {
      Dx1 = Dx1 - 10;
      println("Dx1 = " + Dx1);
    } 
    else if (keyCode == RIGHT) {
      Dx1 = Dx1 + 10;
      println("Dx1 = " + Dx1);
    }
  }
}

void FinOuverture() {
  // minim = new Minim(this);
  // player = minim.loadFile(NomFichierAudio, 1024);
  LecteurAudio[Voix] = minim.loadFile(NomFichierAudio, 1024);

  // FichierOuvert[0] = true;
  xmax = 0;
  IndexXML = -1;
  // Lissage();
  // LecteurAudio[Voix].setPan(-1); // Pan is not supported! Processing 2.2.1 MacOSX.10  minim 3.0 BETA
  // Pan OK Processing 2.0.3 MacOSX.6
  // LecteurAudio[Voix].setVolume(0.1); // Volume is not supported!
  // LecteurAudio[Voix].setBalance(-1); // Balance is not supported!
  // LecteurAudio[Voix].setGain(-20); // OK!
  // LecteurAudio[Voix].play();
  TempsPause = millis();
}

void Ouverture1Fois(int i) { // i = 0 .. 11
  if (!FichierOuvert[i]) {
    FichierOuvert[i] = true;
    Ouverture(TableNomFichier[i], i);
    println("i = " + i + "    " + TableNomFichier[i]);
  }
}

void LecteurFragmentAudio(int Voix, int min, int max) { // min max en ms  
  // if (!LecteurAudio[Voix].isPlaying()) {
  // LecteurAudio[Voix].unmute();
  LecteurAudio[Voix].play(min);
  TempsVoix[Voix] = millis() + max;
  // }
}

int TextX(int x) {
  return x * width / 4 + width / 8;
}

int TextY(int y) {
  return y * height / 3 + height / 6;
  // return y * height / 3 + height / 6 + int(random(180)) - 90 ;
}

void CalculPalette256(int p) { // p = 1 3 5 7 9 0
  if (p == 1) for (int i=0; i<256; i++) Palette256[i] = color(i, 0, 0);
  else if (p ==3) {
    for (int i=0; i<64; i++) {
      Palette256[i]     = color(0, 0, i * 4);           // Black to blue
      Palette256[i+64]  = color(i * 4, i * 4, 252);     // blue to white
      Palette256[i+128] = color(252, 252, (64 - i) * 4);// white to Yellow, 
      Palette256[i+192] = color(252, (126 - i) * 2, 0); // Yellow to Orange
    }
  }
  else if (p ==5) for (int i=0; i<256; i++) Palette256[i] = color(i);
  else if (p ==7) for (int i=0; i<256; i++) Palette256[i] = color(255, i, i);
  else if (p ==9) for (int i=0; i<256; i++) Palette256[i] = color(i, i / 2, i / 2);    
  else if (p ==0) for (int i=0; i<256; i++) Palette256[i] = color(128 + (i / 2), i / 2, i / 2);
}

void CalculInversePalette256() {
  int p;
  for (int i=0; i<128; i++) {
    p = Palette256[i];
    Palette256[i] = Palette256[255 - i];
    Palette256[255 - i] = p;
  }
}

boolean sketchFullScreen() {
  println("PleinEcran = " + PleinEcran);
  return PleinEcran;
}

void stop() {
  println("FIN");
  // always close Minim audio classes when you are done with them
  for (Voix = 0; Voix < NVoix; Voix++) LecteurAudio[Voix].close();
  minim.stop();
  super.stop();
}

